# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

Summary:	Minimal try/catch with proper localization of $@ 
Name:		perl-Try-Tiny
Version:	0.11
Release:	1.%{__distinit}%{__distvers}
License:	MIT
Group:		Development/Libraries
Url:		http://search.cpan.org/dist/Try-Tiny/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DO/DOY/Try-Tiny-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Test::More)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
This module provides bare bones try/catch statements that are designed to
minimize common mistakes with eval blocks, and NOTHING else.

This is unlike TryCatch, which provides a nice syntax and avoids adding
another call stack layer, and supports calling return from the try block to
return from the parent subroutine. These extra features come at a cost of a
few dependencies, namely Devel::Declare and Scope::Upper that are occasionally
problematic, and the additional catch filtering uses Moose type constraints,
which may not be desirable either.

%prep
%setup -q -n Try-Tiny-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes
%{perl_vendorlib}/Try/
%{_mandir}/man3/Try::Tiny.3pm*

%changelog
* Sun Sep  4 2011 Paul Howarth <paul@city-fan.org> 0.11-1
- Update to 0.11
  - Clarify some documentation

* Sat Jul  2 2011 Paul Howarth <paul@city-fan.org> 0.09-2
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Mon Nov 29 2010 Paul Howarth <paul@city-fan.org> 0.09-1
- Update to 0.09
  - Fix require vs use issue in blead (CPAN RT#63410)
  - Don't index Try::Tiny::ScopeGuard
- This release by DOY -> update source URL

* Fri Oct 22 2010 Paul Howarth <paul@city-fan.org> 0.07-1
- Update to 0.07
  - Allow multiple finally blocks
  - Pass the error, if any, to finally blocks when called
- This release by RJBS -> update source URL

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> 0.06-2
- Rebuild for perl 5.12.1 in Rawhide

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> 0.06-1
- Update to 0.06 (test suite fix upstreamed)

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> 0.05-1
- Update to 0.05 (documentation fixes and clarifications)
- Add patch for test suite with Test::More < 0.88

* Mon May 17 2010 Paul Howarth <paul@city-fan.org> 0.04-2
- Fix dist tag for RHEL-6 Beta

* Sat Jan 23 2010 Paul Howarth <paul@city-fan.org> 0.04-1
- Update to 0.04
  - Restore list context propagation for catch blocks
  - Fix a bug where finally blocks weren't always invoked

* Fri Jan 22 2010 Paul Howarth <paul@city-fan.org> 0.03-1
- Update to 0.03
  - Support for 'finally' blocks
  - More documentation and tests
  - Sets $@ to the previous value at the beginning of the eval
- Dist tag for Rawhide no longer needs special-casing

* Wed Sep 16 2009 Paul Howarth <paul@city-fan.org> 0.02-1
- Initial RPM package
